package facturation.appli;

import facturation.dao.ArticleDAO;
import facturation.dao.ClientDAO;
import facturation.dao.ConnectionFactory;
import facturation.logique.FacturationLogique;
import facturation.ui.FacturationTextUI;

public class FacturationApplication {

	private FacturationTextUI ui;
	
	public FacturationApplication() throws ClassNotFoundException {
		// Création de l'application.
		// A) Persistence
		ConnectionFactory connectionFactory= new ConnectionFactory("jdbc:hsqldb:hsql:localhost/base", "sa", "", "org.hsqldb.jdbcDriver");
		ArticleDAO articleDAO= new ArticleDAO(connectionFactory);
		ClientDAO clientDAO= new ClientDAO(connectionFactory);
		// B) logique
		FacturationLogique logique= new FacturationLogique(clientDAO, articleDAO);
		// C) UI
		ui= new FacturationTextUI(logique);
	}
	
	public void executer() {
		ui.menuPrincipal();
	}
	
	public static void main(String[] args) throws ClassNotFoundException {
		FacturationApplication application= new FacturationApplication();
		application.executer();
	}
}
